Package weka.filters.unsupervised.attribute

# Class PropositionalToMultiInstance

java.lang.Object
weka.filters.Filter
weka.filters.unsupervised.attribute.PropositionalToMultiInstance

All Implemented Interfaces:
  `Serializable`, `CapabilitiesHandler`, `OptionHandler`, `RevisionHandler`, `UnsupervisedFilter`

public class PropositionalToMultiInstance extends Filter implements OptionHandler, UnsupervisedFilter
Converts a propositional dataset into a multi-instance dataset (with relational attribute). When normalizing or standardizing a multi-instance dataset, the MultiInstanceToPropositional filter can be applied first to convert the multi-instance dataset into a propositional instance dataset. After normalization or standardization, we may use this PropositionalToMultiInstance filter to convert the data back to multi-instance format.
Note: the first attribute of the original propositional instance dataset must be a nominal attribute which is expected to be the bagId attribute.

Valid options are:

     -no-weights
      Do not weight bags by number of instances they contain. (default off)

     -S <num>
      The seed for the randomization of the order of bags. (default 1)

     -R
      Randomizes the order of the produced bags after the generation. (default off)

Version:
  $Revision: 9666 $
Author:
  Lin Dong (ld21@cs.waikato.ac.nz)
See Also:
  - `MultiInstanceToPropositional`
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`PropositionalToMultiInstance()`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`batchFinished()`
Signify that this batch of input to the filter is finished.
`String`
`doNotWeightBagsTipText()`
Returns the tip text for this property
`Capabilities`
`getCapabilities()`
Returns the Capabilities of this filter.
`boolean`
`getDoNotWeightBags()`
Gets whether the bags are weighted
`String[]`
`getOptions()`
Gets the current settings of the classifier.
`boolean`
`getRandomize()`
Gets whether the order of the generated is randomized
`String`
`getRevision()`
Returns the revision string.
`int`
`getSeed()`
Returns the current seed value for randomizing the order of the generated data
`String`
`globalInfo()`
Returns a string describing this filter
`Enumeration`
`listOptions()`
Returns an enumeration describing the available options
`static void`
`main(String[] args)`
Main method for running this filter.
`String`
`randomizeTipText()`
Returns the tip text for this property
`String`
`seedTipText()`
Returns the tip text for this property
`void`
`setDoNotWeightBags(boolean value)`
Sets whether bags are weighted
`boolean`
`setInputFormat(Instances instanceInfo)`
Sets the format of the input instances.
`void`
`setOptions(String[] options)`
Parses a given list of options.
`void`
`setRandomize(boolean value)`
Sets whether the order of the generated data is randomized
`void`
`setSeed(int value)`
Sets the new seed for randomizing the order of the generated data

### Methods inherited from class weka.filters.Filter

`batchFilterFile, filterFile, getCapabilities, getOutputFormat, input, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, numPendingOutput, output, outputPeek, toString, useFilter, wekaStaticWrapper`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### PropositionalToMultiInstance

public PropositionalToMultiInstance()

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this filter

Returns:
  a description of the filter suitable for displaying in the explorer/experimenter gui

### listOptions

public Enumeration listOptions()
Returns an enumeration describing the available options

Specified by:
  `listOptions` in interface `OptionHandler`
Returns:
  an enumeration of all the available options

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Valid options are:

     -no-weights
      Do not weight bags by number of instances they contain. (default off)

     -S <num>
      The seed for the randomization of the order of bags. (default 1)

     -R
      Randomizes the order of the produced bags after the generation. (default off)

Specified by:
  `setOptions` in interface `OptionHandler`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### getOptions

public String[] getOptions()
Gets the current settings of the classifier.

Specified by:
  `getOptions` in interface `OptionHandler`
Returns:
  an array of strings suitable for passing to setOptions

### seedTipText

public String seedTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### setSeed

public void setSeed(int value)
Sets the new seed for randomizing the order of the generated data

Parameters:
  `value` - the new seed value

### getSeed

public int getSeed()
Returns the current seed value for randomizing the order of the generated data

Returns:
  the current seed value

### randomizeTipText

public String randomizeTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### setRandomize

public void setRandomize(boolean value)
Sets whether the order of the generated data is randomized

Parameters:
  `value` - whether to randomize or not

### getRandomize

public boolean getRandomize()
Gets whether the order of the generated is randomized

Returns:
  true if the order is randomized

### doNotWeightBagsTipText

public String doNotWeightBagsTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### setDoNotWeightBags

public void setDoNotWeightBags(boolean value)
Sets whether bags are weighted

Parameters:
  `value` - whether bags are weighted

### getDoNotWeightBags

public boolean getDoNotWeightBags()
Gets whether the bags are weighted

Returns:
  true if the bags are weighted

### getCapabilities

public Capabilities getCapabilities()
Returns the Capabilities of this filter.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `Filter`
Returns:
  the capabilities of this object
See Also:
  - `Capabilities`

### setInputFormat

public boolean setInputFormat(Instances instanceInfo) throws Exception
Sets the format of the input instances.

Overrides:
  `setInputFormat` in class `Filter`
Parameters:
  `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
Returns:
  true if the outputFormat may be collected immediately
Throws:
  `Exception` - if the input format can't be set successfully

### batchFinished

public boolean batchFinished()
Signify that this batch of input to the filter is finished. If the filter requires all instances prior to filtering, output() may now be called to retrieve the filtered instances.

Overrides:
  `batchFinished` in class `Filter`
Returns:
  true if there are instances pending output
Throws:
  `IllegalStateException` - if no input structure has been defined

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `Filter`
Returns:
  the revision

### main

public static void main(String[] args)
Main method for running this filter.

Parameters:
  `args` - should contain arguments to the filter: use -h for help